> For the complete documentation index, see [llms.txt](https://docs.main.atgraphite.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.main.atgraphite.com/transaction.md).

# Transactions

## Get transaction info

Returns transaction info of a given transaction hash.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=gettxinfo
   &txhash=0x6e3bcabae8fd17c4f4e3dc2ee6346a89fa5542881d6e5cccb68a5d6732aa3f08
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=gettxinfo&txhash=0x6e3bcabae8fd17c4f4e3dc2ee6346a89fa5542881d6e5cccb68a5d6732aa3f08&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter | Description                         |
| --------- | ----------------------------------- |
| txhash\*  | hash of contents of the transaction |

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": {
        "blockHash": "0xf8e5da60865d0b9d47bb4e0cf99098c771515ec562d12b5f7e2b2946542867b0",
        "blockNumber": "41330",
        "confirmations": "1710509",
        "contractAddress": null,
        "cumulativeGasUsed": "188184",
        "decoded": null,
        "epAddress": null,
        "fee": "3387312000000000",
        "from": "0x0aea70d72d5e2218cf9af28410ed388ae03b799b",
        "functionName": null,
        "gas": "188184",
        "gasPrice": "18000000000",
        "gasUsed": "188184",
        "hash": "0x6e3bcabae8fd17c4f4e3dc2ee6346a89fa5542881d6e5cccb68a5d6732aa3f08",
        "input": "0x1a7106730000000000000000000000000000000000000000000000000000000000000003bc0824f80393007f7b83ddc99acedc64179087302cb0d57fba79cf88719b524a",
        "isError": "0",
        "methodId": "0x1a710673",
        "nonce": "46119",
        "receiptStatus": "1",
        "revertReason": null,
        "timeStamp": "1702561026",
        "to": "0x0000000000000000000000000000000000001001",
        "transactionIndex": "0",
        "type": "0",
        "value": "0"
    }
}
```

## Get info for multiple transactions in a single call

Returns transaction info from a list of transaction hashes (maximum of 20 transactions per call).

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=gettxinfomulti
   &txhash=0x7eea5123ad91e4c21a3177cb50f7f6f6287fea52a602f6effb93759d29c6578d,0x804bf3159f80f6bf46ff9daf5f8f73c8111c1d9a16054f67935035135ade8342
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=gettxinfomulti&txhash=0x7eea5123ad91e4c21a3177cb50f7f6f6287fea52a602f6effb93759d29c6578d,0x804bf3159f80f6bf46ff9daf5f8f73c8111c1d9a16054f67935035135ade8342&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter | Description                                                              |
| --------- | ------------------------------------------------------------------------ |
| txhash\*  | the strings representing the hash to check for balance, separated by `,` |

#### Sample response

```json
{
    "status": "1",
    "message": "OK-Missing/Invalid API Key, free rate limit applied",
    "result": [
        {
            "blockHash": "0x5dfeb2237099456093fe9def81d145ec5d80bff57baeb5a9c748bd82b12afc6c",
            "blockNumber": "1751915",
            "confirmations": "122",
            "contractAddress": null,
            "cumulativeGasUsed": "21000",
            "decoded": null,
            "epAddress": null,
            "fee": "378000000000000",
            "from": "0x0aea70d72d5e2218cf9af28410ed388ae03b799b",
            "functionName": null,
            "gas": "26000",
            "gasPrice": "18000000000",
            "gasUsed": "21000",
            "hash": "0x7eea5123ad91e4c21a3177cb50f7f6f6287fea52a602f6effb93759d29c6578d",
            "input": "0x",
            "isError": "0",
            "methodId": null,
            "nonce": "1854378",
            "receiptStatus": "1",
            "revertReason": null,
            "timeStamp": "1726236825",
            "to": "0x0000000000000000000000000000000000000000",
            "transactionIndex": "0",
            "type": "0",
            "value": "864325134364028"
        },
        {
            "blockHash": "0x928b87e92fbb24f22e795c4ed12ffa5780679c3a2aa4de90714041803bf61cb5",
            "blockNumber": "1751916",
            "confirmations": "121",
            "contractAddress": null,
            "cumulativeGasUsed": "21000",
            "decoded": null,
            "epAddress": null,
            "fee": "378000000000000",
            "from": "0x0aea70d72d5e2218cf9af28410ed388ae03b799b",
            "functionName": null,
            "gas": "26000",
            "gasPrice": "18000000000",
            "gasUsed": "21000",
            "hash": "0x804bf3159f80f6bf46ff9daf5f8f73c8111c1d9a16054f67935035135ade8342",
            "input": "0x",
            "isError": "0",
            "methodId": null,
            "nonce": "1854379",
            "receiptStatus": "1",
            "revertReason": null,
            "timeStamp": "1726236837",
            "to": "0x0000000000000000000000000000000000000000",
            "transactionIndex": "0",
            "type": "0",
            "value": "9089481279288811"
        }
    ]
}
```

## Get the total number of confirmed transactions

Returns the total number of confirmed transactions.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=gettotaltxcount
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=gettotaltxcount&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": "1854644"
}
```

## Get pending transactions

Returns a list of pending transactions.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=pendingtxlist
   &offset=0
   &limit=10
   &sort=asc
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=pendingtxlist&offset=0&limit=10&sort=asc&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter | Description                                                                                                     |
| --------- | --------------------------------------------------------------------------------------------------------------- |
| offset    | skips the `offset` records before beginning to return the records, default value is `0`                         |
| limit     | the number of records displayed per page, default value is `10000`                                              |
| sort      | the sorting preference, use `asc` to sort by ascending and `desc` to sort by descending, default value is `asc` |

#### Sample response

```json
{
   "status": "1",
   "message": "OK",
   "result": [
        {
            "blockHash": "0xe495e264658553da8f84a67c0cc0cf5c8178ec1f8de0b0a57475cebd74a2377b",
            "blockNumber": "17573",
            "confirmations": "1734512",
            "contractAddress": null,
            "cumulativeGasUsed": "21000",
            "decoded": null,
            "epAddress": null,
            "fee": "378000000000000",
            "from": "0x0aea70d72d5e2218cf9af28410ed388ae03b799b",
            "functionName": null,
            "gas": "26000",
            "gasPrice": "18000000000",
            "gasUsed": "21000",
            "hash": "0xceeb761a5ab7962096f1b5dc2ce54379b0142c18d023b208815a86df82a14db4",
            "input": "0x",
            "isError": "0",
            "methodId": null,
            "nonce": "21777",
            "receiptStatus": "1",
            "revertReason": null,
            "timeStamp": "1702244586",
            "to": "0x0000000000000000000000000000000000000000",
            "transactionIndex": "0",
            "type": "0",
            "value": "8084928199013178"
        }
    ]
}
```

## Get the number of pending transactions

Returns the number of pending transactions.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=pendingtxcount
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=pendingtxcount&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": "1"
}
```

## Get a list of 'normal' transactions

Returns the list of 'normal' transactions.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=txlist
   &startblock=17563
   &endblock=17573
   &offset=10
   &limit=10
   &sort=asc
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=txlist&startblock=17563&endblock=17573&offset=10&limit=10&sort=asc&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter  | Description                                                                                                     |
| ---------- | --------------------------------------------------------------------------------------------------------------- |
| startblock | the integer block number to start searching for transactions, default value is `0`                              |
| endblock   | the integer block number to stop searching for transactions, default value is `1'000'000'000`                   |
| offset     | skips the `offset` records before beginning to return the records, default value is `0`                         |
| limit      | the number of records displayed per page, default value is `10000`                                              |
| sort       | the sorting preference, use `asc` to sort by ascending and `desc` to sort by descending, default value is `asc` |

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": [
        {
            "blockHash": "0xe495e264658553da8f84a67c0cc0cf5c8178ec1f8de0b0a57475cebd74a2377b",
            "blockNumber": "17573",
            "confirmations": "1734512",
            "contractAddress": null,
            "cumulativeGasUsed": "21000",
            "decoded": null,
            "epAddress": null,
            "fee": "378000000000000",
            "from": "0x0aea70d72d5e2218cf9af28410ed388ae03b799b",
            "functionName": null,
            "gas": "26000",
            "gasPrice": "18000000000",
            "gasUsed": "21000",
            "hash": "0xceeb761a5ab7962096f1b5dc2ce54379b0142c18d023b208815a86df82a14db4",
            "input": "0x",
            "isError": "0",
            "methodId": null,
            "nonce": "21777",
            "receiptStatus": "1",
            "revertReason": null,
            "timeStamp": "1702244586",
            "to": "0x0000000000000000000000000000000000000000",
            "transactionIndex": "0",
            "type": "0",
            "value": "8084928199013178"
        }
    ]
}
```

## Get a list of 'internal' transactions by transaction hash

Returns the list of internal transactions performed within a transaction.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=txlistinternal
   &txhash=0xf63190705bd6459ca40b87b1374ec1a156e0408f7dc73469ea2506e08873b59b
   &includezero=true
   &offset=10
   &limit=10
   &sort=asc
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=txlistinternal&txhash=0xf63190705bd6459ca40b87b1374ec1a156e0408f7dc73469ea2506e08873b59b&includezero=true&offset=10&limit=10&sort=asc&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter   | Description                                                                                                     |
| ----------- | --------------------------------------------------------------------------------------------------------------- |
| txhash\*    | the string representing the transaction hash to check for internal transactions                                 |
| includezero | the boolean flag (`true` or `false`) for including zero value internal transactions, default value is `true`    |
| offset      | skips the `offset` records before beginning to return the records, default value is `0`                         |
| limit       | the number of records displayed per page, default value is `10000`                                              |
| sort        | the sorting preference, use `asc` to sort by ascending and `desc` to sort by descending, default value is `asc` |

#### Sample response

```json
{   
    "status": "1",
    "message": "OK",
    "result": [
        {
            "blockNumber": "1638541",
            "callType": "call",
            "contractAddress": null,
            "errCode": null,
            "from": "0x0000000000000000000000000000000000001001",
            "gas": "2904460",
            "gasUsed": "4467",
            "hash": "0xf63190705bd6459ca40b87b1374ec1a156e0408f7dc73469ea2506e08873b59b",
            "index": "0",
            "input": "0xf340fa010000000000000000000000008d8129f2f56d87f39a3dea1ba33a3bd930849f81",
            "isError": "0",
            "timeStamp": "1724674248",
            "to": "0x0000000000000000000000000000000000001003",
            "traceId": "0",
            "transactionIndex": "0",
            "type": "call",
            "value": "0"
        }
    ]
}
```

## Get a list of 'internal' transactions by block range

Returns the list of internal transactions performed within block range.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=txlistinternal
   &startblock=1638541
   &endblock=1638542
   &offset=10
   &limit=10
   &sort=desc
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=txlistinternal&startblock=1638541&endblock=1638542&offset=10&limit=10&sort=desc&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter    | Description                                                                                                     |
| ------------ | --------------------------------------------------------------------------------------------------------------- |
| startblock\* | the integer block number to start searching for transactions                                                    |
| endblock\*   | the integer block number to stop searching for transactions                                                     |
| offset       | skips the `offset` records before beginning to return the records, default value is `0`                         |
| limit        | the number of records displayed per page, default value is `10000`                                              |
| sort         | the sorting preference, use `asc` to sort by ascending and `desc` to sort by descending, default value is `asc` |

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": [
        {
            "blockNumber": "1638541",
            "callType": "call",
            "contractAddress": null,
            "errCode": null,
            "from": "0x0000000000000000000000000000000000001001",
            "gas": "2904460",
            "gasUsed": "4467",
            "hash": "0xf63190705bd6459ca40b87b1374ec1a156e0408f7dc73469ea2506e08873b59b",
            "index": "0",
            "input": "0xf340fa010000000000000000000000008d8129f2f56d87f39a3dea1ba33a3bd930849f81",
            "isError": "0",
            "timeStamp": "1724674248",
            "to": "0x0000000000000000000000000000000000001003",
            "traceId": "0",
            "transactionIndex": "0",
            "type": "call",
            "value": "0"
        }
    ]
}
```

## Get a number of internal transaction for a transaction

Returns the number of internal transaction for a transaction by its hash.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=getinternaltxcount
   &txhash=0xf63190705bd6459ca40b87b1374ec1a156e0408f7dc73469ea2506e08873b59b
   &includezero=true
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=getinternaltxcount&txhash=0xf63190705bd6459ca40b87b1374ec1a156e0408f7dc73469ea2506e08873b59b&includezero=true&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter   | Description                                                                                                  |
| ----------- | ------------------------------------------------------------------------------------------------------------ |
| txhash\*    | the string representing the transaction hash to check for internal transactions                              |
| includezero | the boolean flag (`true` or `false`) for including zero value internal transactions, default value is `true` |

#### Sample response

```json
{
   "status": "1",
   "message": "OK",
   "result": "1" 
}
```

## Get a list of 'ERC20 - Token Transfer Events' by hash

Returns the list of ERC-20 tokens transferred by hash.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=tokentx
   &hash=0xd2743ca301ecda403a9a4c4ccfbdca5126aff03f30dcbb5a360f12cf78405c84
   &offset=0
   &limit=10
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=tokentx&hash=0xd2743ca301ecda403a9a4c4ccfbdca5126aff03f30dcbb5a360f12cf78405c84&offset=0&limit=10&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter | Description                                                                             |
| --------- | --------------------------------------------------------------------------------------- |
| hash\*    | the string representing the transaction hash                                            |
| offset    | skips the `offset` records before beginning to return the records, default value is `0` |
| limit     | the number of records displayed per page, default value is `10000`                      |

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": [
        {
            "blockHash": "0x9912251ac1f1d6e79cb2156ebd76ae3181c92f9409a6606ca14daa21843f8583",
            "blockNumber": "1732506",
            "confirmations": 19710,
            "contractAddress": "0x8043763af8e103b693e822dae4ccfd70924f6b9e",
            "cumulativeGasUsed": "2702601",
            "from": "0x0000000000000000000000000000000000000000",
            "gas": "2702601",
            "gasPrice": "18000000000",
            "gasUsed": "2702601",
            "hash": "0xd2743ca301ecda403a9a4c4ccfbdca5126aff03f30dcbb5a360f12cf78405c84",
            "index": "0",
            "nonce": "18",
            "timeStamp": "1725971040",
            "to": "0xf8a673a3c162ab71cfb2629beb049289408f8ee3",
            "tokenDecimal": "18",
            "tokenName": "MyToken",
            "tokenPriceUSD": null,
            "tokenSymbol": "MTK",
            "transactionIndex": "0",
            "value": "10000000000000000000"
        }
    ]
}
```

## Get a number of 'ERC20 - Token Transfer Events' by hash

Returns the number of ERC-20 tokens transferred by hash.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=tokentxcount
   &hash=0xd2743ca301ecda403a9a4c4ccfbdca5126aff03f30dcbb5a360f12cf78405c84
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=tokentxcount&hash=0xd2743ca301ecda403a9a4c4ccfbdca5126aff03f30dcbb5a360f12cf78405c84&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter | Description                                  |
| --------- | -------------------------------------------- |
| hash\*    | the string representing the transaction hash |

#### Sample response

```json
{
   "status": "1",
   "message": "OK",
   "result": "1" 
}
```

## Get a list of transactions by called contract method

Returns the list of transaction hashes by called contract method identifier, always sorted by block number in descending order.

#### Sample request

{% tabs %}
{% tab title="Plain" %}

```
https://api.main.atgraphite.com/api
   ?module=transaction
   &action=gettxsbymethod
   &methodid=0x90ec8f7e
   &offset=0
   &limit=10
   &apikey=YourApiKeyToken
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl 'https://api.main.atgraphite.com/api?module=transaction&action=gettxsbymethod&methodid=0x90ec8f7e&offset=0&limit=10&apikey=YourApiKeyToken'
```

{% endtab %}
{% endtabs %}

#### Request query parameters

| Parameter  | Description                                                                             |
| ---------- | --------------------------------------------------------------------------------------- |
| methodid\* | the hex string representing the method id (4 bytes)                                     |
| offset     | skips the `offset` records before beginning to return the records, default value is `0` |
| limit      | the number of records displayed per page, default value is `10000`                      |

#### Sample response

```json
{
    "status": "1",
    "message": "OK",
    "result": [
        "0xcb23dee75e98420005a46600b213542103ff3221f2627a03c882ddd3eb845d5d",
        "0xee677992aa8d38df0d58693c6cae0e7aedcb12a01de3ef3454126136f2c1ef54",
        "0x33b8b5859bd15882188e9a173cc8862ab181df29fe1de5e675ae78c3d46114e3",
        "0xc8b536d1f7a1375a1b960d443a40b988b1e353a3f78afe40cd7194e563bfb349",
        "0x4d7419272b47dc895ebdd7a452efc3e538123bda113d9985051a233c1797c91b"
    ]
}
```
